package net.chat;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.DatagramPacket;
import java.net.InetAddress;
import java.net.MulticastSocket;

/**
 * Copyright DocJava, inc.
 * User: lyon
 * Date: Oct 27, 2004
 * Time: 4:59:20 AM
 */




public class Mchat {

    public static void main(String[] args) throws IOException {
        String strin;
        int port;


        port = 1234;

        InetAddress group = InetAddress.getByName("224.111.112.113");
        if (!group.isMulticastAddress()) {
            System.out.println("The address: " +
                    group +
                    " is not multicast address");
            System.exit(0);

        }

        try {

            MulticastSocket s = new MulticastSocket(port);

            s.setReuseAddress(false);
            System.out.println("ReuseAddress is: " +
                    s.getReuseAddress());

            s.setLoopbackMode(false);
            System.out.println("LoopbackMode is: " +
                    s.getLoopbackMode());


            s.setTimeToLive(2);
            System.out.println("TimeToLive is: " + s.getTimeToLive());

            s.joinGroup(group);

            System.out.println("Joined Group: " +
                    group +
                    " Port:" +
                   port);

            // ChatThread will handle the incoming
            // Data and print it out to STDN output.
            new ChatThread(s);

            // Now read from STDN input and send the Data to the Group.

            BufferedReader myinput = new BufferedReader(
                    new InputStreamReader(System.in));


            System.out.println(
                    "Type anything followed by RETURN," +
                    " or Ctrl+D to  terminate the program.");
            for (; ;) {

                //Read from the STDN input
                strin = myinput.readLine();

                if (strin == null) break; // User Hit Ctrl+D
                DatagramPacket dp = new DatagramPacket(strin.getBytes(),
                        strin.length(),
                        group,
                        port);

                s.send(dp);

            }

            System.out.println("Leaving the Group...");
            s.leaveGroup(group);
            s.close();
        } catch (Exception err) {
            System.err.println("ERR: Can not join the group " + err);
            err.printStackTrace();
            System.exit(1);
        }
    }

}

